################################################################################
# dices.tcl v0.2                                                               #
# Ecrit par Dakin Quelia                                                       #
# Créé le 13/03/2013                                                           #
# LICENSE: GNU GPLv3                                                           #
#                                                                              #
#                                                                              #
# (C) 2013 - Dakin Quelia (http://www.danielchalseche.fr.cr/)                  #
# Pour tout commentaire ou suggestion, contactez-moi via dakinquelia@gmail.com #
#------------------------------------------------------------------------------#
#                                  Description                                 #
#------------------------------------------------------------------------------#
# Ce script vous permet de lancer des jets de dés sur le salon (utile pour un  #
# jeu de rôles).                                                               #
# Utilisation: !dices <nombre de dés> <nombre de faces>                        #
#------------------------------------------------------------------------------#
#                                  Dédicace(s)                                 #
#------------------------------------------------------------------------------#                                  
# Dédicace à Hilu (george.gaetan@gmail.com) qui m'a énormément aidé pour       #
# améliorer le script.                                                         #
#------------------------------------------------------------------------------#
#                              /!\ Attention /!\                               #
#------------------------------------------------------------------------------#
#          Une version de TCL supérieure ou égale à 8.5 est requise            #
#             pour que ce script puisse fonctionner correctement.              #
#------------------------------------------------------------------------------#
#                                 Installation                                 #
#------------------------------------------------------------------------------#
# Ajoutez à la fin du fichier 'eggdrop.conf' l'instruction suivante:           #
#         source -encoding utf-8 "scripts/dices.tcl"                           #
#------------------------------------------------------------------------------#
#                                                                              #                                                              #
#                                                                              #
# * 16/03/2013 v0.2                                                            #
#      Correction du bogue de la boucle                                        #
#      Ajout de la vérification pour l'opérateur                               # 
#                                                                              #
# * 13/03/2013 v0.1                                                            #
#      Début du développement.                                                 #
#                                                                              #
################################################################################
namespace eval "Dices" {
    # Version du script
    set s_version 0.1
    # Script chargé ou non [0/1]
    set b_loaded 1
    # Message du résultat
    set s_dicemsg "Résultat du lancer:" 
	# Lettre "D"
	set s_dmsg "D"
	
	# Jet de dés
	proc dices { nick uhost hand chan arg } {
		global s_dmsg s_dicemsg
		set s_arg $arg
		set s_nick $nick
		set s_chan $chan
		set i_dices [lindex $s_arg 0]
		set i_dicesSides [lindex $s_arg 1]
		set i_dicesCount 0
		# On vérifie que l'utlisateur est modérateur
		if { [ishalfop $s_nick $s_chan] || [isop $s_nick $s_chan] } {
			# Affichage du dé lancé
			if { ($i_dices != "") && ($i_dicesSides != "") } {
				putserv "_____________________________"
				putserv "PRIVMSG $s_chan :Vous lancez un dé de $i_dices$s_dmsg$i_dicesSides"
				while { $i_dicesCount < $i_dices } {
					incr i_dicesCount
					set s_results [expr {int(rand()*$i_dicesSides)}]
					putserv "PRIVMSG $s_chan :$s_dicemsg $s_results"
				}
				putserv "_____________________________"
			} else {
				# Avertit l'utlisateur du manque de paramètre
				putserv "NOTICE $s_nick :Il manque un ou plusieurs paramètres. Utilisation: !dices <nombre de dés> <nombre de faces>"
			}
		} else {
			# Affiche un message de non autorisation
			putserv "NOTICE $s_nick :Vous n'êtes pas autorisé à utiliser cette commande!"
		}
	}
	
	# Pré-rehash
	proc evntPrerehash { s_event } {
        variable b_loaded
        # On remet la variable à 0 avant chaque rehash.
        set b_loaded 0
	}
 
	# Rehash
	proc evntRehash { s_event } {
        variable b_loaded
        if { [string is false -strict $b_loaded] } {
            uninstall
        }
	}
	
	# Désinstallation
	proc uninstall { } {
		unbind PUBM - "!dices" [namespace current]::dices
		bind EVNT - "prerehash" [namespace current]::evntPrerehash
		bind EVNT - "rehash" [namespace current]::evntRehash
		namespace delete [namespace current]
	}
	
	# Autres options (binds, ...)
	bind PUBM - "!dices" [namespace current]::dices
	bind EVNT - "prerehash" [namespace current]::evntPrerehash
	bind EVNT - "rehash" [namespace current]::evntRehash
	
	# Information du chargement du script
	putlog "Dices v0.1 Copyright © 2013 by DakinQuelia"
}